import Taro, { Component } from '@tarojs/taro'
import { View } from '@tarojs/components'

import { AtTabBar } from 'taro-ui'
import './sellerTabBarComponent.scss'



class SellerTabBarComponent extends Component {
    config = {
        navigationBarTitleText: '店铺底栏导航'
    }
    constructor(){
        this.state = {
            current: 0,
            options:[
                { title: '首页', url: '/pages/home/home', iconType: 'bullet-list', text: 'new' },
                { title: '商品发布', url: '/pages/goodsPublish/goodsPublish', iconType: 'camera' },
                { title: '供求发布', url: '/pages/supplyDemandPublish/supplyDemandPublish', iconType: 'folder', text: '100', max: '99' },
                { title: '我的供求', url: '/pages/mySupplyDemand/mySupplyDemand', iconType: 'folder', text: '100', max: '99' },
                { title: '我的需求', url: '/pages/myNeeds/myNeeds', iconType: 'folder', text: '100', max: '99' }
            ]
           
        }
    }
    handleClick(value) {

        this.setState({
            current: value
        })

        let path = this.state.options[value].url
        Taro.navigateTo({
            url: path,
        })

    }

    componentDidMount() {
        
    }
    componentWillReceiveProps(nextProps) {
    }

    componentWillUnmount() { }

    componentDidShow() {
       console.log('this.props.currentUrl',this.props.currentUrl)
        if(this.props.currentUrl==='pages/home/home'){
            this.setState({
                current:0
            })
        }else if(this.props.currentUrl==='pages/supplyDemandPublish/supplyDemandPublish'){
            this.setState({
                current:2
            })
        }
        
     }

    componentDidHide() { }

    render() {
        return (
            <View className='sellerTabBarComponent'>
                <AtTabBar
                  fixed
                  tabList={this.state.options}
                  onClick={this.handleClick.bind(this)}
                  current={this.state.current}
                />

            </View>
        )
    }
}

export default SellerTabBarComponent
