import Taro, { Component } from '@tarojs/taro'
import { View, Image } from '@tarojs/components'
import { AtCurtain } from 'taro-ui'


import URL from '../../../serviceAPI.config'
import './renderingView.scss'
import onClickValueService from '../../../util/onClickValueService'




class RenderingView extends Component {

    //效果图组件 接受：rendering=[]
    config = {
        navigationBarTitleText: '效果图'
    }
    constructor(props) {
        super(props)
        this.state = {
            image: '',
            isOpened: false
        }

    }

    onClickHandler(e) {
        const item = onClickValueService(e)
        this.setState({
            image: URL.Base + item.file_path,
            isOpened: true
        })
    }
    onCloseCurtain() {
        this.setState({
            isOpened: false
        })
    }
    componentDidMount() {

    }
    componentWillReceiveProps(nextProps) {

    }

    componentWillUnmount() { }

    componentDidShow() { }

    componentDidHide() { }

    render() {
        // 显示效果图
        let { rendering } = this.props
        let renderingElementArray = rendering.length ? rendering.map((item, index) => {
            return <View className='image-wrapper' key={index} onClick={this.onClickHandler.bind(this, item)}>
                <Image src={URL.Base + item.file_path} style='max-width:100%; max-height:100%;' />
            </View>
        }) : null;
        let curtainElement = <AtCurtain
            isOpened={this.state.isOpened}
            onClose={this.onCloseCurtain.bind(this)}
        >
            <Image
                style='width:100%;max-height:100%'
                src={this.state.image}
            />
        </AtCurtain>
        return (
            <View className='rendering-container'>
                {curtainElement}
                {renderingElementArray}
            </View>
        )
    }
}

export default RenderingView
