import Taro, { Component } from '@tarojs/taro'
import { View, Button, ScrollView, Text } from '@tarojs/components'

import './clientDemanding.scss'
import onClickValueService from '../../../util/onClickValueService'


class ClientDemanding extends Component {

    passIdToParent(e) {
        this.props.onGrabOrderId(e)
    }
    // 导航去抢单页面
    goToGrabOrderPage(e) {
        const orderId = onClickValueService(e)
        Taro.navigateTo({
            url: '/pages/grabOrderPage/grabOrderPage?orderId=' + orderId
        })
    }

    render() {
        const { ClientDemandingList } = this.props
        const clientDemandingElementArray = ClientDemandingList.length ? ClientDemandingList.map((item, index) => {
            return <View key={index} className={ClientDemandingList.length - 1 === index ? 'demanding-item last' : 'demanding-item'}>
                <View onClick={this.goToGrabOrderPage.bind(this, item.sd_id)}>
                    <View className='item-tag'>
                        <Text className='item-tag-text'> {item.class_name}</Text>
                    </View>
                    <View className='item-title'>
                        {item.sd_title}
                    </View>
                    <View className='item-address'>
                        {item.user_address || '--'}
                    </View>
                    <View className='item-name'>
                        业主：{item.user_name}
                    </View>
                </View>
                {item.state === '1' ? <View className='button' onClick={this.passIdToParent.bind(this, item.sd_id)}>
                    <Button size='mini' className='button-orange'>抢单</Button>
                </View> : null || item.state === '2' ? <View className='button'>
                    <Button size='mini' className='button-orange blur'>{item.state_name}</Button>
                </View> : null || item.state === '3' ? <View className='button'>
                    <Button size='mini' className='button-orange blur'>{item.state_name}</Button>
                </View> : null}

            </View>
        }) : <View />
        return <ScrollView
            style='height100%'
            scrollX
            scrollWithAnimation
            scrollTop='0'
            lowerThreshold='20'
            upperThreshold='20'
            style='white-space: nowrap;'
        >
            {clientDemandingElementArray}
        </ScrollView>
    }
}
export default ClientDemanding
