import Taro, { Component } from '@tarojs/taro'
import { View } from '@tarojs/components'
import { AtGrid, Swiper, SwiperItem } from 'taro-ui'

import URL from '../../../serviceAPI.config'
import './mainCateSlider.scss'


class MainCateSlider extends Component {


    passDataToParent(e) {

        this.props.onScrollFromChild(e)
    }
    componentWillReceiveProps(nextProps) {
        // console.log(this.props, nextProps)
    }

    componentWillUnmount() { }

    componentDidShow() { }

    componentDidHide() { }
    formateSliderData(data) {
        const formatedData = data.map(item => {
            item.image = URL.Base + item.icon
            item.value = item.class_name
            return item
        })
        return formatedData
    }
    render() {
        const { firstSlideData, secondSlideData } = this.props

        const formatedFirstSlideData = firstSlideData ? this.formateSliderData(firstSlideData) : []
        const formatedSecondSlideData = secondSlideData ? this.formateSliderData(secondSlideData) : []

        return (
            <Swiper
            style='height:100%'
                indicatorColor='#999'
                indicatorActiveColor='#333'
                hotizontal
                circular
                indicatorDots
            >
                <SwiperItem>
                    <View style='height:100%'>
                        < AtGrid hasBorder={false} columnNum={5} data={formatedFirstSlideData} onClick={this.passDataToParent.bind(this)} />
                    </View>
                </SwiperItem> <SwiperItem>
                    <View  style='height:100%'>
                        < AtGrid hasBorder={false} columnNum={5} data={formatedSecondSlideData} onClick={this.passDataToParent.bind(this)} />
                    </View>
                </SwiperItem>
            </Swiper>

        )
    }
}

export default MainCateSlider
