import Taro, { Component } from '@tarojs/taro'
import { View } from '@tarojs/components'
import { AtGrid, Swiper, SwiperItem } from 'taro-ui'
import URL from '../../../serviceAPI.config'
import './subCateSlider.scss'


class SubCateSlider extends Component {


    passDataToParent(e) {

        this.props.onClickChildCate(e)
    }

    render() {
        const { subCateList } = this.props
        const subCateElementsArray = subCateList.map((item, index) => {
            return <View key={index} onClick={this.passDataToParent.bind(this, item)} className='view-item'>
                <View className='text'>{item.class_name}</View>
            </View>
        })

        return (

            <ScrollView

                className='scroll-view'
                scrollX
                scrollWithAnimation
                scrollTop='0'
                lowerThreshold='20'
                upperThreshold='20'
                style='white-space: nowrap;'
            >

                {subCateElementsArray}

            </ScrollView>

        )
    }
}

export default SubCateSlider
