import Taro, { Component } from '@tarojs/taro'
import { View, Input, Button, Image } from '@tarojs/components'
import URL from '../../serviceAPI.config'
import standardLogin from '../../util/standardLogin'
import './login.scss'



class Login extends Component {
  config = {
    navigationBarTitleText: '登入'
  }
  constructor() {
    this.state = {
      username: '',
      password: '',
      backgroundImage: 'background-image:url(' + URL.Base + 'Public/images/bg3.jpg);',
      logoIcon:'background-image:url(' + URL.Base + 'Public/images/com-logo.png);'
    }
  }


  usernameHandler(e) {
    let value = e.detail.value
    this.setState({ username: value })
  }
  passwordHandler(e) {
    let value = e.detail.value
    this.setState({ password: value })
  }
  loginHandler() {
    if (this.state.username && this.state.password) {
      standardLogin(this.state.username, this.state.password).then(res => {
        Taro.reLaunch({
          url: '/pages/home/home'
        })
      }).catch(res => {
        Taro.showToast({
          title: res.data.msg,
          icon: 'none',
        })
      })
    } else if (!this.state.username) {
      Taro.showToast({
        title: '请输入用户名',
        icon: 'none',

      })
    } else if (!this.state.password) {
      Taro.showToast({
        title: '请输入密码',
        icon: 'none',

      })
    } else {
      Taro.showToast({
        title: '未知错误请联系管理员',
        icon: 'none',
      })
    }
  }
  componentDidMount() {

  }

  componentWillReceiveProps(nextProps) {
    console.log(this.props, nextProps)
  }

  componentWillUnmount() { }

  componentDidShow() { }

  componentDidHide() { }

  render() {
    return (
      <View className='login'>
        <View className='background' style={this.state.backgroundImage}></View>
        <View className='logo'>
          <View className='image-wrapper'>
            <View className='image-inner-wrapper'>
              <Image className='icon' style={this.state.logoIcon} />
            </View>

            <View className='title'>全屋定制商城</View>
          </View>

        </View>
        <View className='login-wrapper'>
          <View className='title'>用户登入</View>
          <View className='bgtopWrap'>
            <View className='loginWrap'>
              <View className='username'>
                <Input type='text' focus={true} name='username' maxLength='11' placeholder='请输入用户名/手机号' value={this.state.username} onInput={this.usernameHandler} />
              </View>
              <View className='password'>
                <Input type='password' name='password' password={true} placeholder='请输入密码' value={this.state.password} onInput={this.passwordHandler} />
              </View>

              <Button className='button button-orange' onClick={this.loginHandler}>登录</Button>
            </View>
          </View>

        </View>

      </View>
    )
  }
}

export default Login
